from django.db import models
#from mainApp.models import *
from clmainApp.models import Branch,User
from django.utils import timezone
import uuid

# Create your models here.
############## Employee%Module #################
############## Handle Emplyees and Deduction and earnings along month To calculate Salary at the End ################# 
class Department(models.Model):# aksam el3yadat  : batna , taware2 , 2alb , asnan
    name = models.CharField(max_length=75,unique=True)
    #d_icon = models.FileField(upload_to=d_icon_url, null=True, blank=True)
    #is_clinic = models.BooleanField(default=False)
    #d_category = models.CharField(max_length=2, choices=DEPARTMENT_CATEGORY_CHOICES , default="1G")
    #d_order = models.IntegerField("الترتيب", default=add_one_department_order, error_messages={'unique':"توجد عيادة أخري لها نفس رقم الترتيب "})
    def __str__(self):
        return self.name
    # class Meta:
    #     unique_together = ('d_category', 'd_order')

def add_one_job_order():
    largest = Department.objects.order_by('j_order').values('j_order').last()
    if not largest: return 1
    else : return largest["j_order"] + 1
def emp_file_url(instance, filename):
    ext = filename.split('.')[-1]
    return "%s/%s/%s" % ("Employees",instance.id, "{}.{}".format(uuid.uuid4(), ext))

class Employee(models.Model):
    branch = models.ForeignKey(Branch,on_delete=models.PROTECT)
    fullname =  models.CharField(max_length=250,unique=True,help_text ="Employee_name" , verbose_name ="name")
    national_id = models.CharField(max_length=14,blank=True,null=True)
    #edu_qual = models.CharField(max_length=100,blank=True,null=True)#el mo2ahal Educational qualifcations
    number_1 = models.CharField(max_length=20)
    number_2 = models.CharField(max_length=20, blank=True,null=True)
    month_salary = models.IntegerField(default=0)
    #hour_salary = models.FloatField(default=0)
    manager_note = models.CharField(max_length=250,blank=True, null=True)
    balance = models.FloatField(default=0)
    department =  models.ForeignKey(Department,related_name="Employee_department",blank=True,null=True,on_delete=models.PROTECT,)
    is_active = models.BooleanField(default=True,help_text='Unselect this instead of deleting Employee.',)
    qualification_f = models.FileField(upload_to=emp_file_url, null=True, blank=True)
    national_id_f = models.FileField(upload_to=emp_file_url, null=True, blank=True)
    created_by = models.ForeignKey(User,on_delete=models.PROTECT)
    created_at = models.DateTimeField(default=timezone.now)
    hiring_date = models.DateField(blank=True,null=True)
    birth_date = models.DateField(blank=True,null=True)
    training_from_date = models.DateField(blank=True,null=True)
    training_to_date = models.DateField(blank=True,null=True)
    def __str__(self):
        return str(self.fullname)
'''
RATING_OUT_OF_10_CHOICES = (
    (1, 1),# اى قسم عام عدالمخزن والعيادات#General
    ("2C", "عيادة طبية"),# Clinic
    ("3S", "مخزن"),# Stock
    ("4R", "الاستقبال"),# Stock
    ("5E", "الطوارئ"),# Emergency
    ("6L", "المعمل"),# Lab 
)
'''
from django.core.validators import MinValueValidator, MaxValueValidator
#mmkn n3ml fe front end a2l mn 5 a7mr w 5 asfr w aktr mn 5amsa green , fe al gdwal as badges 
class EmpEvaluation(models.Model):
    employee =  models.ForeignKey(
        Employee,
        related_name="EmpEvaluation_employee",
        on_delete=models.PROTECT,
    )
    from_date = models.DateField(blank=True,null=True)
    to_date = models.DateField(blank=True,null=True)
    notes = models.CharField(max_length=250,blank=True, null=True)
    rating_out_of_10 = models.IntegerField(
        validators=[
            MinValueValidator(1, message="Value must be 1 or greater."),
            MaxValueValidator(10, message="Value must be 10 or less.")
        ]
    )
    created_by = models.ForeignKey(User,on_delete=models.PROTECT)
    created_at = models.DateTimeField(default=timezone.now)
    def __str__(self):
        return str(self.employee.fullname)
    
def ea_file_url(instance, filename):
    ext = filename.split('.')[-1]
    return "%s/%s/%s" % ("Employees",instance.employee.id, "{}.{}".format(uuid.uuid4(), ext))
class EmpAttachment(models.Model):
    employee =  models.ForeignKey(
        Employee,
        related_name="EmpAttachment_employee",
        on_delete=models.PROTECT,
    )
    ea_label = models.CharField(max_length=150, blank=True,null=True)
    ea_file = models.FileField(upload_to=ea_file_url, null=True, blank=True)
    notes = models.CharField(max_length=250, blank=True,null=True)
    created_by = models.ForeignKey(User,on_delete=models.DO_NOTHING)
    created_at = models.DateTimeField(default=timezone.now)

    def __str__(self):
        return "{}-{}".format(self.employee.fullname,str(self.created_at))

class DrLevel(models.Model):
    branch = models.ForeignKey(Branch,on_delete=models.PROTECT)
    name = models.CharField(max_length=50)
    session_price = models.IntegerField(default=0)
    bonus_amount = models.IntegerField(default=0)
    deduction_amount = models.IntegerField(default=0)
    notes = models.CharField(max_length=50,blank=True, null=True)
    is_default = models.BooleanField(default=False)
    # class Meta :
    #     unique_together = ('branch', 'is_default')

    def __str__(self):
        return "{} [{}] {}".format(self.name,self.session_price,self.branch.name)
    
class EmpSalary(models.Model):
    total_amount = models.IntegerField(default=0)# elli hytdf3 lel employee # elmost7ak
    total_earning = models.IntegerField(default=0)
    total_deduction = models.IntegerField(default=0)
    emp =  models.ForeignKey(
        Employee,
        related_name="EmpSalary_emp",
        on_delete=models.PROTECT,
    )
    from_day = models.DateField(blank=True,null=True)
    to_day = models.DateField(blank=True,null=True)
    created_by = models.ForeignKey(User,related_name="EmpSalary_created_by",on_delete=models.PROTECT)# اللي حسب المرتب وحط الرقم النهائي 
    created_at = models.DateTimeField(default=timezone.now)#تاريخ إنشاء المرتب 
    #when employee salary delivered to him 
    pay_day = models.DateField(blank=True,null=True)#تاريخ التسليم للموظف 
    deliver_notes = models.CharField(max_length=200,blank=True,null=True) # ملاحظات التسليم 
    delivered_by = models.ForeignKey(User,related_name="EmpSalary_delivered_by",on_delete=models.PROTECT,null=True)# اللي سلم الفلوس للموظف 
   
    def __str__(self):
        return "{}-{}".format(self.emp.fullname,str(self.total_amount))

class Deduction(models.Model):
    name = models.CharField(max_length=100)
    initial_amount = models.IntegerField(default=0)
    def __str__(self):
        return self.name

class Earning(models.Model):
    name = models.CharField(max_length=100)
    initial_amount = models.IntegerField(default=0)
    def __str__(self):
        return self.name

# class AbsenceReason(models.Model):
#     name = models.CharField(max_length=100)
#     is_paid = models.BooleanField(default=False)
#     def __str__(self):
#         return self.name
class EmpDeduction(models.Model):
    amount = models.IntegerField(default=0)
    emp =  models.ForeignKey(
        Employee,
        related_name="EmpDeduction_emp",
        on_delete=models.PROTECT,
    )
    deduction =  models.ForeignKey(
        Deduction,
        related_name="EmpDeduction_deduction",
        on_delete=models.PROTECT,
    )
    salary = models.ForeignKey(EmpSalary,on_delete=models.PROTECT,null=True)
    is_done = models.BooleanField(default=False,help_text='select if month is finished w kol 7aga 5adha el mowzf most7akato')
    deduction_note = models.CharField(max_length=120,blank=True,null=True)
    created_by = models.ForeignKey(User,on_delete=models.PROTECT)
    created_at = models.DateTimeField(default=timezone.now)

    def __str__(self):
        return "{}__{}__{}".format(self.emp.fullname,self.deduction.name,str(self.amount))

class EmpEarning(models.Model):
    amount = models.IntegerField(default=0)
    emp =  models.ForeignKey(
        Employee,
        related_name="EmpEarning_emp",
        on_delete=models.PROTECT,
    )
    earning =  models.ForeignKey(
        Earning,
        related_name="EmpDeduction_earning",
        on_delete=models.PROTECT,
    )
    salary = models.ForeignKey(EmpSalary,on_delete=models.PROTECT,null=True)
    is_done = models.BooleanField(default=False,help_text='select if month is finished w kol 7aga 5adha el mowzf most7akato')
    earning_note = models.CharField(max_length=120,blank=True,null=True)
    created_by = models.ForeignKey(User,on_delete=models.PROTECT)
    created_at = models.DateTimeField(default=timezone.now)

    def __str__(self):
        return "{}__{}__{}".format(self.emp.fullname,self.earning.name,str(self.amount))

'''

class EmpSalaryAdvance(models.Model):
    amount = models.IntegerField(default=0)
    emp =  models.ForeignKey(Employee,related_name="EmpSalaryAdvance_emp",on_delete=models.PROTECT,)
    sa_note = models.CharField(max_length=120,blank=True,null=True)#salary advance note 
    salary = models.ForeignKey(EmpSalary,on_delete=models.PROTECT,null=True)
    is_done = models.BooleanField(default=False,help_text='select if month is finished w kol 7aga 5adha el mowzf most7akato')
    created_by = models.ForeignKey(User,on_delete=models.PROTECT)
    created_at = models.DateTimeField(default=timezone.now)

    def __str__(self):
        return "{}__{}__{}".format(self.emp.fullname,self.earning.name,str(self.amount))
'''
'''
class EmpAbsence(models.Model):
    emp =  models.ForeignKey( Employee,related_name="EmpAbsence_emp",on_delete=models.PROTECT,)
    day = models.DateField(auto_now_add=True)
    absence_reason = models.ForeignKey(AbsenceReason,related_name="EmpAbsence_absence_reason",on_delete=models.PROTECT)
    absence_note = models.CharField(max_length=100,blank=True,null=True)
    absence_note_by = models.ForeignKey(User,blank=True,null=True,related_name="Attendance_absence_note_by",on_delete=models.PROTECT)
    salary = models.ForeignKey(EmpSalary,on_delete=models.PROTECT,null=True)
    is_done = models.BooleanField(default=False)
    class Meta :
        unique_together = ('emp', 'day')
    def __str__(self):
        return str(self.emp.name,"-",self.day)
'''
#هجمع الساعات لنفس اليوم حتى لو أكتر من record 
class EmpAttendance(models.Model):
    emp = models.ForeignKey( Employee,related_name="EmpAttendance_emp",on_delete=models.PROTECT,)
    day = models.DateField(auto_now_add=True)
    check_in = models.TimeField(auto_now_add=True)
    check_in_note = models.CharField(max_length=100,blank=True,null=True)
    check_in_by = models.ForeignKey(User,related_name="EmpAttendance_check_in_by",on_delete=models.PROTECT)
    check_out = models.DateTimeField(blank=True,null=True)
    check_out_note = models.CharField(max_length=100,blank=True,null=True)
    check_out_by = models.ForeignKey(User,blank=True,null=True,related_name="EmpAttendance_check_out_by",on_delete=models.PROTECT)
    salary = models.ForeignKey(EmpSalary,on_delete=models.PROTECT,null=True)
    is_done = models.BooleanField(default=False)
    # class Meta :
    #     unique_together = ('emp', 'day')
    def __str__(self):
        return "{}-{}".format(self.emp.fullname, str(self.day))

############## END Employee%Module #################